﻿Public Class frmWW
    Dim bytOLD() As Byte
    Dim bolOLD As Boolean
    Public Sub New()
        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        strパス = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location)
    End Sub
    Private Function 選択行(ByVal bolCHK As Boolean) As Integer
        For intROW = 0 To lstTTL.Items.Count - 1
            If lstTTL.Items(intROW).Selected Then Return intROW
        Next
        If bolCHK Then
            Call MessageBox.Show("一覧が選択されていません。", strNAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
        End If
        Return -1
    End Function
    Private Sub txtWLK_DragDrop(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles txtWLK.DragDrop
        Dim strFLE() As String

        strFLE = CType(e.Data.GetData(DataFormats.FileDrop), String())
        If strFLE.Length - 1 < 0 Then Exit Sub
        If System.IO.Path.GetExtension(strFLE(0).ToLower) <> ".wlk" Then Exit Sub

        txtWLK.Text = strFLE(0)
        Call WLK読み込み()
    End Sub
    Private Sub txtWLK_DragEnter(sender As Object, e As System.Windows.Forms.DragEventArgs) Handles txtWLK.DragEnter
        Call File_DragEnter(sender, e)
    End Sub
    Private Sub btnWLK_Click(sender As System.Object, e As System.EventArgs) Handles btnWLK.Click
        Dim strBUF As String = ""
        If Not FILE_DLG(Me, strBUF, "WAVE LINKファイル(*.wlk)|*.wlk", True) Then Exit Sub

        txtWLK.Text = strBUF
        Call WLK読み込み()
    End Sub
    Private Sub txtWLK_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles txtWLK.KeyDown
        If e.KeyCode <> Keys.Enter Then Exit Sub
        Call WLK読み込み()
    End Sub
    Private Sub lstTTL_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstTTL.DragDrop
        Dim strFLE() As String

        strFLE = CType(e.Data.GetData(DataFormats.FileDrop), String())
        If strFLE.Length - 1 < 0 Then Exit Sub

        For Each strCHK In strFLE
            Select Case System.IO.Path.GetExtension(strCHK.ToLower)
                Case ".wav"
                    Call リスト追加(strCHK)
                Case ".wlk"
                    txtWLK.Text = strCHK
                    Call WLK読み込み()
                    Exit Sub
            End Select
        Next

        If chkソート.Checked Then
            Call リストソート(enm項目.ファイル名, SortOrder.Ascending)
        End If
        lstTTL.Items(0).Selected = True
    End Sub
    Private Sub lstTTL_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstTTL.DragEnter
        Call File_DragEnter(sender, e)
    End Sub
    Private Sub lstTTL_SelectedIndexChanged(sender As Object, e As System.EventArgs) Handles lstTTL.SelectedIndexChanged
        Dim intIDX As Integer

        intIDX = 選択行(False)
        If intIDX = -1 Then Exit Sub

        With lstTTL.Items(intIDX)
            chk排他.Checked = CBool(.SubItems(enm項目.排他再生).Text)
            chkループ.Checked = CBool(.SubItems(enm項目.ループ再生).Text)
            txt音量.Text = .SubItems(enm項目.音量).Text
            txtパン.Text = .SubItems(enm項目.パン).Text
            txt周波数.Text = .SubItems(enm項目.周波数).Text
            txt優先度.Text = .SubItems(enm項目.優先度).Text
        End With

    End Sub
    Private Sub リスト追加(strFLE As String)
        Dim objLST As ListViewItem
        Dim intMAX As Integer
        Dim bytBUF() As Byte

        intMAX = lstTTL.Items.Count
        If intMAX >= 255 Then Exit Sub

        objLST = New ListViewItem
        For intCNT = 1 To 20
            objLST.SubItems.Add("")
        Next

        ReDim bytBUF(0)
        Call バイナリ読込(strFLE, bytBUF)
        With objLST
            .SubItems(enm項目.番号).Text = intMAX
            .SubItems(enm項目.ファイル名).Text = System.IO.Path.GetFileName(strFLE)
            .SubItems(enm項目.ファイル名長さ).Text = LenB(.SubItems(enm項目.ファイル名).Text)
            .SubItems(enm項目.パス).Text = strFLE
            .SubItems(enm項目.パス長さ).Text = LenB(.SubItems(enm項目.パス).Text)
            .SubItems(enm項目.ビット).Text = bytBUF(enmWAV.BIT_POS)
            .SubItems(enm項目.チャンネル数).Text = bytBUF(enmWAV.CNL_POS)
            .SubItems(enm項目.排他再生).Text = "False"
            .SubItems(enm項目.ループ再生).Text = "False"
            .SubItems(enm項目.音量).Text = "0"
            .SubItems(enm項目.パン).Text = "0"
            .SubItems(enm項目.周波数).Text = BitConverter.ToUInt32(bytBUF, enmWAV.SMP_POS)
            If chk優先度.Checked Then
                .SubItems(enm項目.優先度).Text = "255"
            Else
                .SubItems(enm項目.優先度).Text = "0"
            End If
            .SubItems(enm項目.WAVE位置).Text = "0"
            .SubItems(enm項目.WAVEサイズ).Text = BitConverter.ToUInt32(bytBUF, enmWAV.LEN_POS)
            .SubItems(enm項目.WLK).Text = "False"
        End With

        Call lstTTL.BeginUpdate()
        Call lstTTL.Items.Insert(intMAX, objLST)
        Call lstTTL.EndUpdate()
        Call 状態設定(intMAX)
        Call lstTTL.Items(0).EnsureVisible()

    End Sub
    Private Sub リストソート(ByVal intSEL As Integer, ByVal srtSRT As SortOrder)
        Dim cmpLST As ItemComparer
        Dim strCOL()() As String

        If intSEL = 0 Or lstTTL.Items.Count - 1 = 0 Then Exit Sub

        strCOL = New String(lstTTL.Items.Count - 1)() {}
        cmpLST = New ItemComparer(srtSRT)

        For intROW = 0 To lstTTL.Items.Count - 1
            strCOL(intROW) = New String(lstTTL.Columns.Count - 1) {}
            For intCOL = 1 To lstTTL.Columns.Count - 1
                strCOL(intROW)(intCOL) = lstTTL.Items(intROW).SubItems(intCOL).Text
            Next
            strCOL(intROW)(enm項目.ソート) = strCOL(intROW)(intSEL)
        Next

        Array.Sort(strCOL, cmpLST)

        For intROW = 0 To lstTTL.Items.Count - 1
            lstTTL.Items(intROW).SubItems(enm項目.番号).Text = intROW
            For intCOL = 2 To lstTTL.Columns.Count - 1
                lstTTL.Items(intROW).SubItems(intCOL).Text = strCOL(intROW)(intCOL)
            Next
        Next

    End Sub
    Private Sub 状態設定(intROW As Integer)
        Dim strBUF As String
        With lstTTL.Items(intROW)
            strBUF = .SubItems(enm項目.ビット).Text
            If .SubItems(enm項目.チャンネル数).Text = "1" Then
                strBUF = strBUF & "M"
            Else
                strBUF = strBUF & "S"
            End If
            If CBool(.SubItems(enm項目.ループ再生).Text) Then
                strBUF = strBUF & "L"
            Else
                strBUF = strBUF & "-"
            End If
            If CBool(.SubItems(enm項目.排他再生).Text) Then
                strBUF = strBUF & "-"
            Else
                strBUF = strBUF & "C"
            End If
            .SubItems(enm項目.状態).Text = strBUF
        End With
    End Sub
    Private Sub btnWAV保存_Click(sender As System.Object, e As System.EventArgs) Handles btnWAV保存.Click
        Dim strDIR As String = ""
        Dim strNAM As String
        Dim strWLK As String
        Dim bytWAV() As Byte
        Dim bytWRK() As Byte
        Dim intFRQ As UInteger
        Dim intBLK As Integer

        If Not bolOLD Then
            Call MessageBox.Show("WLKファイルを読み込んでいません。", strNAME, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
        If Not DIR_DLG(Me, strDIR) Then Exit Sub

        strWLK = IO.Path.GetFileNameWithoutExtension(txtWLK.Text)

        For intIDX = 0 To lstTTL.Items.Count - 1
            With lstTTL.Items(intIDX)
                If CBool(.SubItems(enm項目.WLK).Text) Then
                    ReDim bytWAV(Val(.SubItems(enm項目.WAVEサイズ).Text) + 43)
                    bytWAV(0) = 82      'R
                    bytWAV(1) = 73      'I
                    bytWAV(2) = 70      'F
                    bytWAV(3) = 70      'F
                    bytWRK = BitConverter.GetBytes(CType(bytWAV.Length - 8, UInt32))
                    bytWAV(4) = bytWRK(0)       'バイト数
                    bytWAV(5) = bytWRK(1)
                    bytWAV(6) = bytWRK(2)
                    bytWAV(7) = bytWRK(3)
                    bytWAV(8) = 87      'W
                    bytWAV(9) = 65      'A
                    bytWAV(10) = 86     'V
                    bytWAV(11) = 69     'E
                    bytWAV(12) = 102    'f
                    bytWAV(13) = 109    'm
                    bytWAV(14) = 116    't
                    bytWAV(15) = 32     ' '
                    bytWAV(16) = 16     'バイト数
                    bytWAV(20) = 1      'フォーマットID
                    bytWAV(22) = .SubItems(enm項目.チャンネル数).Text
                    intFRQ = Val(.SubItems(enm項目.周波数).Text)
                    bytWRK = BitConverter.GetBytes(intFRQ)
                    bytWAV(24) = bytWRK(0)     'サンプリングレート
                    bytWAV(25) = bytWRK(1)
                    bytWAV(26) = bytWRK(2)
                    bytWAV(27) = bytWRK(3)
                    intBLK = Val(.SubItems(enm項目.チャンネル数).Text)
                    If Val(.SubItems(enm項目.ビット).Text) = 16 Then intBLK = intBLK * 2
                    intFRQ = intFRQ * intBLK
                    bytWRK = BitConverter.GetBytes(intFRQ)
                    bytWAV(28) = bytWRK(0)      'データ速度 
                    bytWAV(29) = bytWRK(1)
                    bytWAV(30) = bytWRK(2)
                    bytWAV(31) = bytWRK(3)
                    bytWAV(32) = intBLK         'ブロックサイズ
                    bytWAV(34) = Val(.SubItems(enm項目.ビット).Text) 'bit
                    bytWAV(36) = 100    'd
                    bytWAV(37) = 97     'a
                    bytWAV(38) = 116    't
                    bytWAV(39) = 97     'a
                    bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.WAVEサイズ).Text, UInt32))
                    bytWAV(40) = bytWRK(0)      'バイト数
                    bytWAV(41) = bytWRK(1)
                    bytWAV(42) = bytWRK(2)
                    bytWAV(43) = bytWRK(3)
                    Buffer.BlockCopy(bytOLD, Val(.SubItems(enm項目.WAVE位置).Text), bytWAV, 44, Val(.SubItems(enm項目.WAVEサイズ).Text))

                    strNAM = strDIR & "\" & strWLK & Format(intIDX, "000") & ".WAV"
                    Call バイナリ書込(strNAM, bytWAV)
                End If
            End With
        Next

        Beep()
    End Sub
    Private Sub btnWLK保存_Click(sender As System.Object, e As System.EventArgs) Handles btnWLK保存.Click
        Dim strFLE As String = ""
        Dim bytWLK() As Byte
        Dim bytWRK() As Byte
        Dim bytWAV() As Byte
        Dim intSUM As UInteger
        Dim intSTT As Integer
        Dim intHED As Integer
        Dim intBDY As Integer

        ReDim bytWLK(0)
        ReDim bytWAV(0)

        If Not FILE_DLG(Me, strFLE, "WAVE LINKファイル(*.wlk)|*.wlk", False) Then Exit Sub

        If chkWLKF0200.Checked Then
            intHED = 12
            If chkファイル名.Checked Then
                intBDY = 34
            Else
                intBDY = 22
            End If
        Else
            intHED = 2
            intBDY = 14
        End If

        intSTT = intHED + intBDY * lstTTL.Items.Count

        intSUM = intSTT
        For intIDX = 0 To lstTTL.Items.Count - 1
            With lstTTL.Items(intIDX)
                .SubItems(enm項目.WAVE新位置).Text = intSUM
                intSUM = intSUM + Val(.SubItems(enm項目.WAVEサイズ).Text)
            End With
        Next
        If chkWLKF0200.Checked And chkファイル名.Checked Then
            For intIDX = 0 To lstTTL.Items.Count - 1
                With lstTTL.Items(intIDX)
                    .SubItems(enm項目.ファイル名位置).Text = intSUM
                    intSUM = intSUM + Val(.SubItems(enm項目.ファイル名長さ).Text)
                End With
            Next
            For intIDX = 0 To lstTTL.Items.Count - 1
                With lstTTL.Items(intIDX)
                    .SubItems(enm項目.パス位置).Text = intSUM
                    If chkパス.Checked Then
                        intSUM = intSUM + Val(.SubItems(enm項目.パス長さ).Text)
                    End If
                End With
            Next
        End If

        ReDim bytWLK(intSUM - 1)

        If chkWLKF0200.Checked Then
            bytWLK(0) = &H57    'W
            bytWLK(1) = &H4C    'L
            bytWLK(2) = &H4B    'K
            bytWLK(3) = &H46    'F
            bytWLK(4) = &H30    '0
            bytWLK(5) = &H32    '2
            bytWLK(6) = &H30    '0
            bytWLK(7) = &H30    '0
            bytWRK = BitConverter.GetBytes(CType(lstTTL.Items.Count, UShort))
            bytWLK(8) = bytWRK(0)
            bytWLK(9) = bytWRK(1)

            If chkファイル名.Checked Then
                bytWLK(10) = 3
                bytWLK(11) = 0
            Else
                bytWLK(10) = 0
                bytWLK(11) = 0
            End If
        Else
            bytWRK = BitConverter.GetBytes(CType(lstTTL.Items.Count - 1, UShort))
            bytWLK(0) = bytWRK(0)
            bytWLK(1) = bytWRK(1)
        End If

        For intIDX = 0 To lstTTL.Items.Count - 1
            Call 排他ループ結合(bytWLK(intHED + intIDX * intBDY + 1), lstTTL.Items(intIDX))
            With lstTTL.Items(intIDX)
                bytWLK(intHED + intIDX * intBDY + 0) = Val(.SubItems(enm項目.優先度).Text)
                bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.WAVE新位置).Text, UInt32))
                bytWLK(intHED + intIDX * intBDY + 2) = bytWRK(0)
                bytWLK(intHED + intIDX * intBDY + 3) = bytWRK(1)
                bytWLK(intHED + intIDX * intBDY + 4) = bytWRK(2)
                bytWLK(intHED + intIDX * intBDY + 5) = bytWRK(3)
                bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.WAVEサイズ).Text, UInt32))
                bytWLK(intHED + intIDX * intBDY + 6) = bytWRK(0)
                bytWLK(intHED + intIDX * intBDY + 7) = bytWRK(1)
                bytWLK(intHED + intIDX * intBDY + 8) = bytWRK(2)
                bytWLK(intHED + intIDX * intBDY + 9) = bytWRK(3)
                bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.周波数).Text, UInt32))
                bytWLK(intHED + intIDX * intBDY + 10) = bytWRK(0)
                bytWLK(intHED + intIDX * intBDY + 11) = bytWRK(1)
                bytWLK(intHED + intIDX * intBDY + 12) = bytWRK(2)
                bytWLK(intHED + intIDX * intBDY + 13) = bytWRK(3)
                If chkWLKF0200.Checked Then
                    bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.音量).Text, Int32))
                    bytWLK(intHED + intIDX * intBDY + 14) = bytWRK(0)
                    bytWLK(intHED + intIDX * intBDY + 15) = bytWRK(1)
                    bytWLK(intHED + intIDX * intBDY + 16) = bytWRK(2)
                    bytWLK(intHED + intIDX * intBDY + 17) = bytWRK(3)
                    bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.パン).Text, Int32))
                    bytWLK(intHED + intIDX * intBDY + 18) = bytWRK(0)
                    bytWLK(intHED + intIDX * intBDY + 19) = bytWRK(1)
                    bytWLK(intHED + intIDX * intBDY + 20) = bytWRK(2)
                    bytWLK(intHED + intIDX * intBDY + 21) = bytWRK(3)
                End If
                If chkWLKF0200.Checked And chkファイル名.Checked Then
                    bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.ファイル名位置).Text, UInt32))
                    bytWLK(intHED + intIDX * intBDY + 22) = bytWRK(0)
                    bytWLK(intHED + intIDX * intBDY + 23) = bytWRK(1)
                    bytWLK(intHED + intIDX * intBDY + 24) = bytWRK(2)
                    bytWLK(intHED + intIDX * intBDY + 25) = bytWRK(3)
                    bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.ファイル名長さ).Text, UShort))
                    bytWLK(intHED + intIDX * intBDY + 26) = bytWRK(0)
                    bytWLK(intHED + intIDX * intBDY + 27) = bytWRK(1)
                    bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.パス位置).Text, UInt32))
                    bytWLK(intHED + intIDX * intBDY + 28) = bytWRK(0)
                    bytWLK(intHED + intIDX * intBDY + 29) = bytWRK(1)
                    bytWLK(intHED + intIDX * intBDY + 30) = bytWRK(2)
                    bytWLK(intHED + intIDX * intBDY + 31) = bytWRK(3)
                    If chkパス.Checked Then
                        bytWRK = BitConverter.GetBytes(CType(.SubItems(enm項目.パス長さ).Text, UShort))
                        bytWLK(intHED + intIDX * intBDY + 32) = bytWRK(0)
                        bytWLK(intHED + intIDX * intBDY + 33) = bytWRK(1)
                    End If
                End If
            End With
        Next

        For intIDX = 0 To lstTTL.Items.Count - 1
            With lstTTL.Items(intIDX)
                If CBool(.SubItems(enm項目.WLK).Text) Then
                    Buffer.BlockCopy(bytOLD, Val(.SubItems(enm項目.WAVE位置).Text), bytWLK, Val(.SubItems(enm項目.WAVE新位置).Text), Val(.SubItems(enm項目.WAVEサイズ).Text))
                Else
                    Call バイナリ読込(.SubItems(enm項目.パス).Text, bytWAV)
                    Buffer.BlockCopy(bytWAV, enmWAV.DAT_POS, bytWLK, Val(.SubItems(enm項目.WAVE新位置).Text), Val(.SubItems(enm項目.WAVEサイズ).Text))
                End If
            End With
        Next

        If chkWLKF0200.Checked And chkファイル名.Checked Then
            For intIDX = 0 To lstTTL.Items.Count - 1
                With lstTTL.Items(intIDX)
                    bytWRK = CHAR_BYTE(.SubItems(enm項目.ファイル名).Text)
                    Buffer.BlockCopy(bytWRK, 0, bytWLK, Val(.SubItems(enm項目.ファイル名位置).Text), Val(.SubItems(enm項目.ファイル名長さ).Text))
                End With
            Next
        End If
        If chkWLKF0200.Checked And chkファイル名.Checked And chkパス.Checked Then
            For intIDX = 0 To lstTTL.Items.Count - 1
                With lstTTL.Items(intIDX)
                    bytWRK = CHAR_BYTE(.SubItems(enm項目.パス).Text)
                    Buffer.BlockCopy(bytWRK, 0, bytWLK, Val(.SubItems(enm項目.パス位置).Text), Val(.SubItems(enm項目.パス長さ).Text))
                End With
            Next
        End If

        Call バイナリ書込(strFLE, bytWLK)
        Beep()
    End Sub
    Private Sub btnクリア_Click(sender As System.Object, e As System.EventArgs) Handles btnクリア.Click
        txtWLK.Text = ""
        Call リストクリア()
        bolOLD = False
    End Sub
    Private Sub リストクリア()
        Call lstTTL.BeginUpdate()
        Call lstTTL.Items.Clear()
        Call lstTTL.EndUpdate()
    End Sub
    Private Sub WLK読み込み()
        Dim objLST As ListViewItem
        Dim bytCHK() As Byte
        Dim shtCNT As UShort
        Dim shtLEN As UShort
        Dim bolNAM As Boolean
        Dim bol200 As Boolean
        Dim intPOS As Integer
        Dim intSTT As Integer

        Call リストクリア()

        ReDim bytOLD(0)
        ReDim bytCHK(7)
        bolOLD = バイナリ読込(txtWLK.Text, bytOLD)
        If Not bolOLD Then Exit Sub

        Buffer.BlockCopy(bytOLD, 0, bytCHK, 0, 8)

        If BYTE_CHAR(bytCHK) = "WLKF0200" Then
            bol200 = True
            shtCNT = BitConverter.ToUInt16(bytOLD, 8)
            bolNAM = BitConverter.ToUInt16(bytOLD, 10) = 3
        Else
            shtCNT = BitConverter.ToUInt16(bytOLD, 0) + 1
        End If

        chkWLKF0200.Checked = bol200
        chkファイル名.Checked = bolNAM
        chkパス.Checked = False

        For intIDX = 0 To shtCNT - 1
            If bolNAM Then
                intPOS = intIDX * 34 + 12
            ElseIf bol200 Then
                intPOS = intIDX * 22 + 12
            Else
                intPOS = intIDX * 14 + 2
            End If

            objLST = New ListViewItem
            For intCNT = 1 To 20
                objLST.SubItems.Add("")
            Next

            Call 排他ループ分解(bytOLD(intPOS + 1), objLST)
            With objLST
                .SubItems(enm項目.番号).Text = intIDX
                .SubItems(enm項目.WAVE位置).Text = BitConverter.ToUInt32(bytOLD, intPOS + 2)
                .SubItems(enm項目.WAVEサイズ).Text = BitConverter.ToUInt32(bytOLD, intPOS + 2 + 4)
                .SubItems(enm項目.周波数).Text = BitConverter.ToUInt32(bytOLD, intPOS + 2 + 8)
                .SubItems(enm項目.WLK).Text = "True"
                If bol200 Then
                    .SubItems(enm項目.優先度).Text = bytOLD(intPOS)
                    .SubItems(enm項目.音量).Text = BitConverter.ToInt32(bytOLD, intPOS + 2 + 12)
                    .SubItems(enm項目.パン).Text = BitConverter.ToInt32(bytOLD, intPOS + 2 + 16)
                    If bolNAM Then
                        shtLEN = BitConverter.ToUInt16(bytOLD, intPOS + 2 + 24)
                        ReDim bytCHK(shtLEN - 1)
                        intSTT = BitConverter.ToUInt32(bytOLD, intPOS + 2 + 20)
                        Buffer.BlockCopy(bytOLD, intSTT, bytCHK, 0, shtLEN)
                        .SubItems(enm項目.ファイル名).Text = BYTE_CHAR(bytCHK)
                        .SubItems(enm項目.ファイル名長さ).Text = shtLEN
                        shtLEN = BitConverter.ToUInt16(bytOLD, intPOS + 2 + 30)
                        If shtLEN > 0 Then
                            ReDim bytCHK(shtLEN - 1)
                            intSTT = BitConverter.ToUInt32(bytOLD, intPOS + 2 + 26)
                            Buffer.BlockCopy(bytOLD, intSTT, bytCHK, 0, shtLEN)
                            .SubItems(enm項目.パス).Text = BYTE_CHAR(bytCHK)
                            If intIDX = 0 Then chkパス.Checked = True
                        End If
                        .SubItems(enm項目.パス長さ).Text = shtLEN
                    Else
                        .SubItems(enm項目.ファイル名).Text = "No Label Data"
                        .SubItems(enm項目.ファイル名長さ).Text = LenB(.SubItems(enm項目.ファイル名).Text)
                        .SubItems(enm項目.パス長さ).Text = "0"
                    End If
                Else
                    .SubItems(enm項目.優先度).Text = "0"
                    .SubItems(enm項目.音量).Text = "0"
                    .SubItems(enm項目.パン).Text = "0"
                End If

            End With

            Call lstTTL.BeginUpdate()
            Call lstTTL.Items.Insert(intIDX, objLST)
            Call lstTTL.EndUpdate()
            Call 状態設定(intIDX)
        Next

        If lstTTL.Items.Count = 0 Then Exit Sub
        lstTTL.Items(0).Selected = True
        Call lstTTL.Items(0).EnsureVisible()
    End Sub
    Private Sub 排他ループ分解(bytDAT As Byte, objLST As ListViewItem)
        With objLST
            Select Case bytDAT And &HF0
                Case &H0, &H20, &H40, &H60
                    .SubItems(enm項目.ビット).Text = 8
                    If bytDAT >= &H40 Then
                        .SubItems(enm項目.チャンネル数).Text = 2
                    Else
                        .SubItems(enm項目.チャンネル数).Text = 1
                    End If
                Case &H80, &HA0, &HC0, &HE0
                    objLST.SubItems(enm項目.ビット).Text = 16
                    If bytDAT >= &HC0 Then
                        .SubItems(enm項目.チャンネル数).Text = 2
                    Else
                        .SubItems(enm項目.チャンネル数).Text = 1
                    End If
            End Select
            .SubItems(enm項目.排他再生).Text = CBool(bytDAT And &H1)
            .SubItems(enm項目.ループ再生).Text = CBool(bytDAT And &H20)
        End With
        ' 8bitモノラル（なし00　排他01　排他＆ループ21　ループ20）
        ' 8bitステレオ（なし40　排他41　排他＆ループ61　ループ60）
        '16bitモノラル（なし80　排他81　排他＆ループA1　ループA0）
        '16bitステレオ（なしC0　排他C1　排他＆ループE1　ループE0）
    End Sub
    Private Sub 排他ループ結合(ByRef bytDAT As Byte, objLST As ListViewItem)
        With objLST
            If .SubItems(enm項目.ビット).Text = "16" Then
                If .SubItems(enm項目.チャンネル数).Text = "2" Then
                    bytDAT = &HC0
                Else
                    bytDAT = &H80
                End If
            ElseIf .SubItems(enm項目.チャンネル数).Text = "2" Then
                    bytDAT = &H40
            End If
            If CBool(.SubItems(enm項目.排他再生).Text) Then
                bytDAT = bytDAT + 1
            End If
            If CBool(.SubItems(enm項目.ループ再生).Text) Then
                bytDAT = bytDAT + &H20
            End If
        End With
    End Sub
    Private Sub txtパン_TextChanged(sender As Object, e As System.EventArgs) Handles txtパン.TextChanged
        If Val(txtパン.Text) < trkパン.Minimum Or Val(txtパン.Text) > trkパン.Maximum Then Exit Sub
        trkパン.Value = Val(txtパン.Text)
        Call 選択行設定(enm項目.パン, txtパン.Text)
    End Sub
    Private Sub txt音量_TextChanged(sender As System.Object, e As System.EventArgs) Handles txt音量.TextChanged
        If Val(txt音量.Text) < trk音量.Minimum Or Val(txt音量.Text) > trk音量.Maximum Then Exit Sub
        trk音量.Value = Val(txt音量.Text)
        Call 選択行設定(enm項目.音量, txt音量.Text)
    End Sub
    Private Sub txt周波数_TextChanged(sender As Object, e As System.EventArgs) Handles txt周波数.TextChanged
        If Val(txt周波数.Text) < trk周波数.Minimum Or Val(txt周波数.Text) > trk周波数.Maximum Then Exit Sub
        trk周波数.Value = Val(txt周波数.Text)
        Call 選択行設定(enm項目.周波数, txt周波数.Text)
    End Sub
    Private Sub txt優先度_TextChanged(sender As Object, e As System.EventArgs) Handles txt優先度.TextChanged
        If Val(txt優先度.Text) < trk優先度.Minimum Or Val(txt優先度.Text) > trk優先度.Maximum Then Exit Sub
        trk優先度.Value = Val(txt優先度.Text)
        Call 選択行設定(enm項目.優先度, txt優先度.Text)
    End Sub
    Private Sub trkパン_ValueChanged(sender As Object, e As System.EventArgs) Handles trkパン.ValueChanged
        txtパン.Text = trkパン.Value
        Call 選択行設定(enm項目.パン, txtパン.Text)
    End Sub
    Private Sub trk音量_ValueChanged(sender As Object, e As System.EventArgs) Handles trk音量.ValueChanged
        txt音量.Text = trk音量.Value
        Call 選択行設定(enm項目.音量, txt音量.Text)
    End Sub
    Private Sub trk周波数_ValueChanged(sender As Object, e As System.EventArgs) Handles trk周波数.ValueChanged
        txt周波数.Text = trk周波数.Value
        Call 選択行設定(enm項目.周波数, txt周波数.Text)
    End Sub
    Private Sub trk優先度_ValueChanged(sender As Object, e As System.EventArgs) Handles trk優先度.ValueChanged
        txt優先度.Text = trk優先度.Value
        Call 選択行設定(enm項目.優先度, txt優先度.Text)
    End Sub
    Private Sub chkループ_CheckedChanged(sender As Object, e As System.EventArgs) Handles chkループ.CheckedChanged
        Call 選択行設定(enm項目.ループ再生, CStr(chkループ.Checked))
    End Sub
    Private Sub chk排他_CheckedChanged(sender As Object, e As System.EventArgs) Handles chk排他.CheckedChanged
        Call 選択行設定(enm項目.排他再生, CStr(chk排他.Checked))
    End Sub
    Private Sub 選択行設定(intCOL As enm項目, strWRK As String)
        Dim intIDX As Integer
        intIDX = 選択行(False)
        If intIDX = -1 Then Exit Sub
        lstTTL.Items(intIDX).SubItems(intCOL).Text = strWRK
        Call 状態設定(intIDX)
    End Sub
End Class
